diff -urN ppp-2.4.5/pppd/auth.c ppp-2.4.5.patched/pppd/auth.c
--- ppp-2.4.5/pppd/auth.c	2009-11-16 23:26:07.000000000 +0100
+++ ppp-2.4.5.patched/pppd/auth.c	2013-08-11 19:34:27.055665149 +0200
@@ -237,6 +237,7 @@
 bool explicit_remote = 0;	/* User specified explicit remote name */
 bool explicit_user = 0;		/* Set if "user" option supplied */
 bool explicit_passwd = 0;	/* Set if "password" option supplied */
+bool explicit_myip = 0;	/* Set if "password" option supplied */
 char remote_name[MAXNAMELEN];	/* Peer's name for authentication */
 
 static char *uafname;		/* name of most recent +ua file */
@@ -365,6 +366,10 @@
       "Set name for auth with peer", OPT_PRIO | OPT_STATIC,
       &explicit_user, MAXNAMELEN },
 
+    { "myip", o_string, myip,
+      "Set server ip", OPT_PRIO | OPT_STATIC,
+      &explicit_myip, MAXNAMELEN },
+
     { "password", o_string, passwd,
       "Password for authenticating us to the peer",
       OPT_PRIO | OPT_STATIC | OPT_HIDE,
diff -urN ppp-2.4.5/pppd/options.c ppp-2.4.5.patched/pppd/options.c
--- ppp-2.4.5/pppd/options.c	2009-11-16 23:26:07.000000000 +0100
+++ ppp-2.4.5.patched/pppd/options.c	2013-08-11 19:07:55.361314337 +0200
@@ -110,6 +110,7 @@
 bool	log_default = 1;	/* log_to_fd is default (stdout) */
 int	maxfail = 10;		/* max # of unsuccessful connection attempts */
 char	linkname[MAXPATHLEN];	/* logical name for link */
+char	myip[MAXNAMELEN];	/* my ip address */
 bool	tune_kernel;		/* may alter kernel settings */
 int	connect_delay = 1000;	/* wait this many ms after connect script */
 int	req_unit = -1;		/* requested interface unit */
@@ -251,6 +252,10 @@
       "Don't send log messages to any file descriptor",
       OPT_PRIOSUB | OPT_ALIAS | OPT_NOARG | OPT_VAL(-1) },
 
+    { "myip", o_string, myip,
+      "Set my IP address",
+      OPT_PRIO | OPT_PRIV | OPT_STATIC, NULL, MAXNAMELEN},
+
     { "linkname", o_string, linkname,
       "Set logical name for link",
       OPT_PRIO | OPT_PRIV | OPT_STATIC, NULL, MAXPATHLEN },
diff -urN ppp-2.4.5/pppd/plugins/radius/ip_util.c ppp-2.4.5.patched/pppd/plugins/radius/ip_util.c
--- ppp-2.4.5/pppd/plugins/radius/ip_util.c	2009-11-16 23:26:07.000000000 +0100
+++ ppp-2.4.5.patched/pppd/plugins/radius/ip_util.c	2013-08-11 20:56:49.169728857 +0200
@@ -124,6 +124,9 @@
 
 UINT4 rc_own_ipaddress(void)
 {
+	if (myip != NULL)
+		return htonl(inet_addr(myip));
+
 	static UINT4 this_host_ipaddr = 0;
 
 	if (!this_host_ipaddr) {
diff -urN ppp-2.4.5/pppd/plugins/radius/radius.c ppp-2.4.5.patched/pppd/plugins/radius/radius.c
--- ppp-2.4.5/pppd/plugins/radius/radius.c	2009-11-16 23:26:07.000000000 +0100
+++ ppp-2.4.5.patched/pppd/plugins/radius/radius.c	2013-08-11 20:58:25.362862915 +0200
@@ -947,6 +947,7 @@
 	UNTIMEOUT(radius_acct_interim, NULL);
 
     rstate.accounting_started = 0;
+
     rc_avpair_add(&send, PW_ACCT_SESSION_ID, rstate.session_id,
 		   0, VENDOR_NONE);
 
diff -urN ppp-2.4.5/pppd/pppd.h ppp-2.4.5.patched/pppd/pppd.h
--- ppp-2.4.5/pppd/pppd.h	2009-11-16 23:26:07.000000000 +0100
+++ ppp-2.4.5.patched/pppd/pppd.h	2013-08-11 19:21:17.238439755 +0200
@@ -309,6 +309,7 @@
 extern bool	sync_serial;	/* Device is synchronous serial device */
 extern int	maxfail;	/* Max # of unsuccessful connection attempts */
 extern char	linkname[MAXPATHLEN]; /* logical name for link */
+extern char     myip[MAXNAMELEN];
 extern bool	tune_kernel;	/* May alter kernel settings as necessary */
 extern int	connect_delay;	/* Time to delay after connect script */
 extern int	max_data_rate;	/* max bytes/sec through charshunt */
